use crate::error::CustomError;

use super::registry::Registry;
use super::IObject;

/// Essentially a no-op since the keyword is not rendered and any relevant impact on other elements is pulled from the parsed form of keyword.
#[derive(Debug)]
pub(crate) struct IKeyword {}

impl IKeyword {
    pub(crate) async fn new<'parse>(
        registry: &mut Registry<'parse>,
        keyword: &organic::types::Keyword<'parse>,
    ) -> Result<IKeyword, CustomError> {
        Ok(IKeyword {})
    }
}
