use crate::error::CustomError;
use crate::intermediate::util::coalesce_whitespace;

use super::registry::Registry;

#[derive(Debug)]
pub(crate) struct IPlainText {
    source: String,
}

impl IPlainText {
    pub(crate) async fn new<'parse>(
        registry: &mut Registry<'parse>,
        plain_text: &organic::types::PlainText<'parse>,
    ) -> Result<IPlainText, CustomError> {
        Ok(IPlainText {
            source: coalesce_whitespace(plain_text.source).into_owned(),
        })
    }
}
